Subject: Summary: what makes Gaussian fast ?

From: [email-masked] (Teerakiat Kerdcharoen)
Date: Thu, 12 Jan 1995 13:24:44 +0100 (NFT)

Dear netters,
        Thank you very much for your response. I have learned a lot from
you responses. Now, I can answer myself somehow why Gaussian is faster than
the other. I have attached those I have received at the end of this mail.
                                                             take care,
                                                             Teerakiat
------------------------------  original question --------------------------
Dear cyber-chemists,
        I have experienced using both GAMESS and Gaussian 92 on
AIX platform. Gaussian 92 always runs faster than GAMESS in
most case. I have found on a review article where written Gaussian
spend the computation at the cost of N**2.7 not N**4 as 
conventional Hartree-Fock scheme (N = no. of Gaussian primitives).
        Which special algorithms are tailored into Gaussian ?
Could somebody point me out a hint or direct me the the proper
references I could read through in more detail. Thanks a lot for
any responses.
                                                take care,
                                                Teerakiat

 PS. The energy obtained from GAMESS is always lower than from
     Gaussian. Therefore, I believe that the speed is gained
     at the sacrifice of some precision.

------------------------- compilation of responses -------------------------

From: [email-masked] (Akinori MURAKAMI)

>> Dear cyber-chemists,	???

>>         I have experienced using both GAMESS and Gaussian 92 on
>> AIX platform. Gaussian 92 always runs faster than GAMESS in
>> most case. I have found on a review article where written Gaussian
>> spend the computation at the cost of N**2.7 not N**4 as 
>> conventional Hartree-Fock scheme (N = no. of Gaussian primitives).

That is not true for conventional method.
There are only small amount of nonzero integrals(greater than
10**(-10)) and number of those scale as N**(2-3). 
N**4 is formal scaling not real time computation.

cf. R. Ahlichs, Theor. Chim. Acta. vol 33, p157, (1974)

>>         Which special algorithms are tailored into Gaussian ?

Most integral are evaluated by HP(axis rotation method) in both
Gaussian and HONDO(GAMESS).
Some integrals are evaluated by HGP and PRISM in Gaussian is faster
than Rys method in HONDO(GAMESS0. I think that is not main difference.

Gaussian seems clever selection for integral evaluation.
I don't know the paper. You can imagine from the original paper on
direct SCF, J. Almolef, K. Faegri, K. Korsell, J. Comput. Chem. vol 3.
p385 (1982).

>>  PS. The energy obtained from GAMESS is always lower than from
>>      Gaussian. Therefore, I believe that the speed is gained
>>      at the sacrifice of some precision.

I think your mention about one point calculation. 
Gaussian use loose conversion threshold, 10**(-4).

We get same energy on Gaussian and GAMESS(HONDO).

Best regards.

Akinori Murakami
Mitsubishi Chemical Corporation

-----------------------------------------------------------------------
From: [email-masked] (Michael Probst)

Hi, Noy !
No reasonable Hartree-Fock program scales with N^4.
The power of 2-3 comes from the way in which calculation of near-0 integrals
is avoided: The programs get always smarter in this.
For large chemical systems the power becomes 2 for a ' perfect program'
or even smaller if tricks like FMM are used.
I think Gamess has a bit old integral routines that make it slower than Gaussian.
Btw, for example turbomole is normally faster than Gaussian.
The results of both programs must really be the same up to at least 6 digits
after the comma otherwise (1) there are different tresholds or hidden differences
in coordinates or so or (2) there is a real bug.

Greetings !
 How is life going ?

Michael

------------------------------------------------------------------------

From: "Dr. Rene Fournier" <[email-masked]>

   Hi ; One reason why Gaussian is very fast is because of its
efficient calculation of integrals which is very well described in:
      P. M. W. Gill, Adv. Quantum Chem. 25, 143 (1994).

   Rene Fournier      [email-masked]

------------------------------------------------------------------------

From: David Heisterberg <[email-masked]>

>most case. I have found on a review article where written Gaussian
>spend the computation at the cost of N**2.7 not N**4 as 

That's an observed scaling, and all codes behave similarly.  The
rate-limiting step for most SCF runs is generation and/or subsequent
reading of the two-electron integrals, which theoretically grow as
N^4.  However, in generating them one typically "screens out"
integrals that will be small because the centers involved are far
apart.  These are simply not computed and considered 0.  If you
throw away integrals for which the appropriate centers are greater
than a distance, R, apart, and consider a molecule to be roughly
spherical, then the number of centers within distance R of a given
one only grows as N^3 rather an N^4.

>        Which special algorithms are tailored into Gaussian ?

Gaussian does have a very fast integral program.  The Gaussian manual
lists references for the important papers.  The PRISM algorithm is
pretty smart about choosing the best way to evaluate integrals given
the angular momentum and length of contraction.  But ultimately they
are done based on the recurrence relations of King, Dupuis, and Rys
or those of McMurchie and Davidson.

> PS. The energy obtained from GAMESS is always lower than from

Gaussian has somewhat looser criteria for discarding integrals
that Gamess, but you can change this and get the same result
from both codes.

>     Gaussian. Therefore, I believe that the speed is gained
>     at the sacrifice of some precision.

Yes!
--
David J. Heisterberg ([email-masked])      Gee, it's so beautiful, I gotta
The Ohio Supercomputer Center           give somebody a sock in the jaw.
Columbus, Ohio                          -- Little Skippy (Percy Crosby)

-------------------------------------------------------------------------

From: Bob Zellmer <[email-masked]>

Are you talking about a single point calculation or a geometry optimization?
I believe that when a geom. opt. is done using G92 the threshold for
throwing integrals out (treating them as equal to zero) is lower in the
early part of the opt. when far away from the optimized geometry.  This
may also be true for single points depending on how the calculation is
done (incore, direct, etc.).   There is some limited control over the
threshold for keeping integrals. 
This is why G92 would both be faster than GAMESS and less precise (slightly
higher energy).

I believe it does mention this in the manual, but I don't remember
where.  I hope this helps a little bit.

Robert Zellmer
Chemistry Dept.
The Ohio State University
Columbus, OH 43017
[email-masked]
--------------------------------------------------------------------------

From: husuter <[email-masked]>

Dear Mr. Kerdchar,

the time difference between G92 and GAMESS is mainly due
to other integral routines. The GAMESS/HONDO uses the old
Rys-Dupuis routines and some of the G80 routines, look for
example at the papers of the group of M. Dupuis,
J.Chem.Phys. 65(1976)111 and J.Comp.Phys 21 (1976) 144.
The integral routines of the G92++ series are of newer date
and you may find them with the reference M. Head-Gordon and
J.A. Pople, J.Chem.Phys. 89 (1988) 5777.  There is a quite
good introduction of the problems of integral evaluation in
the last Advances of Quantum Chemistry, from P.M.W. Gill.
I would recommend you to look at it.

I have also observed that the GAMESS is trastically slower than
the newer versions of Gaussian, but there are things which you
have to consider too. First of all the GAMESS uses 6d functions,
and it may be that you compare with 5d functions in G92. 
The energies will be different! Secondly the default for the 
integral neglection threshold (that is what finally makes
that the n**4 dependence vanisches) is rather conservative in
GAMESS and HONDO (10**-12), which is not necessary except you
have very diffuse functions. 
I am also sure that the people of GAMESS-US, will defend
their Program, so you may hear something about possible
improvements from their side.

                                hope this helps,

                                  Hans Ulrich  Suter
-----------------------------------------------------------------------